package locasto.monocrack;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import java.util.*;


public class TestGUI extends JFrame implements ActionListener{


	private JMenuBar menuBar;

	private JMenuItem exit;
	private JMenuItem help;
	private JMenuItem about;


	private JLabel statusBar;

	private Container c;

	private JTextArea output;
	private JTextArea input;
	private JButton submit; //capture
	private JButton clear; //new ciphertext
	private JTextField replace;
	private JTextField with;
	private JButton doReplace;

	private static Font font=Font.decode( "Courier-PLAIN-14" );

	private char [] cipherText = new char[0];

	private char [] decodedText = new char[0];



	public TestGUI(){

		super( "Monocrack helper v1" );
		
		c = getContentPane();
		c.setLayout( new BorderLayout() );

		menuBar = new JMenuBar();
		setJMenuBar( menuBar );

		exit = new JMenuItem( "Exit" );
		exit.setMnemonic( 'x' );
		JMenu clientMenu = new JMenu( "File" );
		clientMenu.setMnemonic( 'F' );
		clientMenu.add( exit );

		menuBar.add( clientMenu );

		help = new JMenuItem( "Help" );
		help.setMnemonic( 'e' );
		about = new JMenuItem( "About" );
		about.setMnemonic( 'A' );

		JMenu helpMenu = new JMenu( "Help" );
		helpMenu.setMnemonic( 'H' );

		helpMenu.add( help );
		helpMenu.addSeparator();
		helpMenu.add( about );

		menuBar.add( helpMenu );

		statusBar = new JLabel( "Status: " );
		JPanel southPanel = new JPanel( new BorderLayout() );
			replace = new JTextField( "", 2 );
			with = new JTextField( "", 2 );
			doReplace = new JButton( "Replace!" );
			JPanel nsPanel = new JPanel( new GridLayout(1,5) );
			nsPanel.add( new JLabel( "Replace character" ) );
			nsPanel.add( replace );
			nsPanel.add( new JLabel( "with character" ) );
			nsPanel.add( with );
			nsPanel.add( doReplace );

			southPanel.add(	nsPanel, BorderLayout.NORTH );

		southPanel.add( statusBar, BorderLayout.SOUTH );
		c.add( southPanel, BorderLayout.SOUTH );

		JPanel northPanel = new JPanel( new BorderLayout() );

			input = new JTextArea( "", 6, 60 );
			input.setEditable( true );
			input.setEnabled( true );
			input.setFont( font );
		
			submit = new JButton( "Capture" );			
			clear = new JButton( "Clear" );			

			northPanel.add( new JScrollPane( input ), BorderLayout.NORTH );
			JPanel snPanel = new JPanel( new GridLayout( 1, 5 ) );
			snPanel.add( submit );
			snPanel.add( clear );
			snPanel.add( new JLabel( "" ) );
			snPanel.add( new JLabel( "" ) );
			northPanel.add( snPanel, BorderLayout.SOUTH );

		c.add( northPanel, BorderLayout.NORTH );

		JPanel centerPanel = new JPanel( new BorderLayout() );
			output = new JTextArea( "", 8, 60 );
			output.setEditable( false );
			output.setFont( font );
			centerPanel.add( new JScrollPane( output ), BorderLayout.CENTER );
		c.add( centerPanel, BorderLayout.CENTER );

		submit.addActionListener( this );
		clear.addActionListener( this );
		exit.addActionListener( this );
		doReplace.addActionListener( this );
		help.addActionListener( this );
		about.addActionListener( this );


		input.setEnabled( true );
		submit.setEnabled( true );
		doReplace.setEnabled( false );

		setSize( 550, 520 );
		setLocation( 100, 55 );
		setVisible( true );
	}

	private void display(){

		output.setText( "" );
		statusBar.setText( "length=" + cipherText.length );
		int totalChars = cipherText.length;
		int i=0;
		StringBuffer sBuffer = new StringBuffer( 120 );
		StringBuffer sBuffer1 = new StringBuffer( 120 );

		while( i<totalChars ){
			 sBuffer1.append( cipherText[ i ] );
			 sBuffer.append( decodedText[ i ] );

			if( i==0 ){

			}else if( (i%58==0) || ((i+1)==totalChars) ){
				sBuffer1.append( '\n' );
				output.append( sBuffer1.toString() );
				sBuffer.append( '\n' );
				output.append( sBuffer.toString() );
				output.append( "\n" );
				sBuffer1=sBuffer1.delete( 0, sBuffer1.length() );
				sBuffer=sBuffer.delete( 0, sBuffer.length() );
			}

			i++;
		}

	}

	public void actionPerformed( ActionEvent aevt ){

		if( aevt.getSource() == exit ){
			System.exit( 0 );
		}else if( aevt.getSource() == doReplace ){

			char [] r = replace.getText().toCharArray();
			char [] w = with.getText().toCharArray();
			if( r==null || r.length==0 || w==null || w.length==0 )
				return;
			
			for( int i=0;i<cipherText.length;i++ ){

				if( cipherText[i]==r[0] ){
					decodedText[ i ] = w[0];
				}
			}
			display();
			replace.setText( "" );
			with.setText( "" );

		}else if( aevt.getSource() == submit ){
			
			//capture ciphertext, setInput uneditable
			input.setEditable( false );
			input.setEnabled( false );
			cipherText = input.getText().toCharArray();
			decodedText = new char[ cipherText.length ];
			for( int i=0;i<decodedText.length;i++ ){
				decodedText[ i ] = '\0';
			}
			submit.setEnabled( false );
			doReplace.setEnabled( true );
			display();
			
		}else if( aevt.getSource() == help ){

			JOptionPane.showMessageDialog( this,
											"Help not yet implemented.",
											"Help Not Available",
											JOptionPane.INFORMATION_MESSAGE );

		}else if( aevt.getSource() == about ){

			JOptionPane.showMessageDialog( this,
											"Monocrack GUI v1\n\nMichael E. Locasto",
											"About",
											JOptionPane.INFORMATION_MESSAGE );

		}else if( aevt.getSource() == clear ){
			input.setText( "" );
			input.setEnabled( true );
			input.setEditable( true );
			output.setText( "" );
			submit.setEnabled( true );
			doReplace.setEnabled( false );
		}
	}


	public static void main( String [] args ){

		try{
			TestGUI application = new TestGUI();
			application.addWindowListener(
				new WindowAdapter(){
					public void windowClosing( WindowEvent winevt ){
						System.exit( 0 );
					}
				}
			);
			
		}catch( Exception e ){

		}
	}


}
